#include "efence.h"

#include "plugin.h"
#include "list.h"
#include <stdlib.h>

d_plugin_data_t*
plugin_data_new(int id, void *data)
{
    d_plugin_data_t *pd = malloc(sizeof(d_plugin_data_t));
    pd->id = id;
    pd->data = data;
    return pd;
}

void
plugin_data_free(d_plugin_data_t *pd)
{
    if (pd) free(pd);
}

void
plugin_data_add(d_list_t *list, int id, void *data)
{
    d_plugin_data_t *pd;
    pd = plugin_data_new(id, data);
    list_append(list, pd);
}

void*
plugin_data_find(d_list_t *list, int id)
{
    d_list_it_t *it;
    for (it = list_top(list); it; it = it->next) {
        d_plugin_data_t *pd = it->data;
        if (pd->id == id) return pd->data;
    }
    return NULL;
}

void
plugin_data_remove(d_list_t *list, int id)
{
    d_list_it_t *it, *next;
    for (it = list_top(list); it; it = next) {
        d_plugin_data_t *pd = it->data;
        next = it->next;
        if (pd->id == id) {
            list_delete_link(list, it);
            plugin_data_free(pd);
        }
    }
}
